<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Teknisa\MAN\Services\RelObsParticularidadesVendaService;
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities;

class RelObsParticularidadesVenda {
    
    protected $dataSourceName = 'vnd0161A_relObsParticularidadesVenda';
    protected $obsParticularidadesVenda;
    protected $utilService;
    
    public function __construct (RelObsParticularidadesVendaService $obsParticularidadesVenda, Utilities\Util $utilService ){
        $this->utilService = $utilService;
        $this->obsParticularidadesVenda = $obsParticularidadesVenda;
    }
    
    public function findReport(Request\Filter $request, Response $response) {
        try{
            $result = [];
            $conditions = $this->utilService->getParamsAsArray($request);
            if(isset($conditions['CDFILIAL']) && !empty($conditions['CDFILIAL'])) {
                $response->addDataSet(new DataSet($this->dataSourceName, $this->obsParticularidadesVenda->getObservacoes($conditions)));
                return $response;
            }
            return $result;
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }
}